/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { XRipple } from "./XRipple";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { ElevationHelper } from "./ElevationHelper";
import { ButtonDisplayStyle_$type } from "./ButtonDisplayStyle";
import { isNaN_ } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { Thickness } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { UIElementPropertyAccessorFactory } from "igniteui-react-core";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
/**
 * @hidden
 */
export let ButtonView = /*@__PURE__*/ (() => {
    class ButtonView extends Base {
        constructor() {
            super();
            this.b = null;
            this.k = null;
            this.d = null;
            this.h = new List$1(Delegate_$type, 0);
            this.e = true;
            this.n = null;
            this.j = NaN;
            this.i = NaN;
            this.l = null;
            this.c = null;
            this.m = null;
            this.p = null;
            this.o = null;
        }
        aj() {
        }
        g() {
            return true;
        }
        get q() {
            return this.n;
        }
        get r() {
            return this.m;
        }
        ad(a) {
            if (a == null) {
                for (let b of fromEnum(this.h)) {
                    b();
                }
                this.h.clear();
                return;
            }
            this.k = a;
            this.k.rootWrapper.setStyleProperty("display", "flex");
            this.k.rootWrapper.setStyleProperty("flex-direction", "row");
            this.k.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.k.rootWrapper.setStyleProperty("align-items", "center");
            let c = this.k.createElement("button");
            this.n = c;
            this.n.setStyleProperty("position", "relative");
            this.n.setStyleProperty("display", "inline-flex");
            this.n.setStyleProperty("align-items", "center");
            this.n.setStyleProperty("justify-content", "center");
            this.as();
            this.n.setStyleProperty("border", "none");
            this.n.setStyleProperty("cursor", "pointer");
            this.n.setStyleProperty("user-select", "none");
            this.n.setStyleProperty("outline-style", "none");
            this.n.setStyleProperty("-webkit-tap-highlight-color", "transparent");
            this.n.setStyleProperty("overflow", "hidden");
            this.n.setStyleProperty("white-space", "no-wrap");
            this.n.setStyleProperty("color", "#000");
            this.n.setStyleProperty("background", this.b.m8._fill);
            NativeUI.m(this.n, this.b.kc);
            this.n.setAttribute("id", this.b.h8);
            this.ap();
            this.h.add(c.listen("change", runOn(this, this.w)));
            this.h.add(c.listen("click", runOn(this, this.x)));
            this.h.add(c.listen("focus", runOn(this, this.y)));
            this.h.add(c.listen("blur", runOn(this, this.v)));
            this.h.add(this.k.rootWrapper.listen("mouseenter", runOn(this, this.t)));
            this.h.add(this.k.rootWrapper.listen("mouseleave", runOn(this, this.u)));
            this.k.append(c);
            let d = this.k.createElement("div");
            let e = this.k.getSubRenderer(d);
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            d.setStyleProperty("left", "0px");
            d.setStyleProperty("top", "0px");
            d.setStyleProperty("overflow", "hidden");
            let f = new XRipple();
            f.provideContainer(e);
            f.q = c;
            let g = this.k.getExternal(f, this.k.rootWrapper, this.k.getExternal(this.b, null, null));
            f.h = false;
            f.k = true;
            this.c = f;
            this.n.append(d);
            let h = this.k.createElement("div");
            h.addClass("ig-button-content");
            h.setStyleProperty("font-family", "Verdana");
            h.setStyleProperty("font-weight", "400");
            h.setStyleProperty("font-size", ".875rem");
            h.setStyleProperty("cursor", "pointer");
            this.m = h;
            this.h.add(h.listen("click", runOn(this, this.s)));
            this.n.append(h);
            this.o = h;
            this.k.getPortal(h, "ChildContent", (i) => {
                let comp_ = i.componentRef;
                this.p = comp_;
                {
                    this.o.setStyleProperty("flex-direction", this.b.hf);
                    this.o.setStyleProperty("align-items", this.b.fw);
                    let direction_ = this.b.hf;
                    let display_ = this.b.gc;
                    let alignItems_ = this.b.fw;
                    comp_.display = display_;
                    comp_.flexDirection = direction_;
                    comp_.alignItems = alignItems_;
                }
            }, true);
            this.b.jz();
        }
        af() {
            this.c.i = this.b.ae;
        }
        as() {
            let a = "2.25rem";
            let b = "2.25rem";
            let c = "2.25rem";
            let d = "2.25rem";
            let e = "3.5rem";
            let f = "3.5rem";
            let g = "3.5rem";
            let h = "3.5rem";
            let i = "5.5rem";
            let j = "2.25rem";
            let k = "0px";
            let l = ".9375rem";
            let m = ".5625rem 1rem";
            switch (this.b.l) {
                case 2:
                    m = ".375rem .75rem";
                    j = "1.875rem";
                    e = "3rem";
                    f = "3rem";
                    g = "3rem";
                    h = "3rem";
                    l = ".6875rem";
                    break;
                case 3:
                    m = ".1875rem 1rem";
                    j = "1.5rem";
                    f = "2.5rem";
                    e = "2.5rem";
                    h = "2.5rem";
                    g = "2.5rem";
                    l = ".4375rem";
                    break;
            }
            if (this.b.e == 4) {
                this.n.setStyleProperty("min-width", a);
                this.n.setStyleProperty("min-height", b);
                this.n.setStyleProperty("padding", k);
                this.n.setStyleProperty("width", c);
                this.n.setStyleProperty("height", d);
            }
            else if (this.b.e == 3) {
                this.n.setStyleProperty("min-width", e);
                this.n.setStyleProperty("min-height", f);
                this.n.setStyleProperty("padding", l);
                this.n.setStyleProperty("width", g);
                this.n.setStyleProperty("height", h);
            }
            else {
                this.n.setStyleProperty("min-width", i);
                this.n.setStyleProperty("min-height", j);
                this.n.setStyleProperty("padding", m);
            }
            if (!isNaN_(this.b.aw) && this.b.aw > 0) {
                this.n.setStyleProperty("border-style", "solid");
            }
            else {
                this.n.setStyleProperty("border-style", "none");
            }
            if (!isNaN_(this.j)) {
                this.n.setStyleProperty("min-width", this.j.toString() + "px");
            }
            if (!isNaN_(this.i)) {
                this.n.setStyleProperty("min-height", this.i.toString() + "px");
            }
        }
        ao(a) {
            this.j = a;
        }
        an(a) {
            this.i = a;
        }
        al() {
            this.n.setAttribute("disabled", this.b.disabled ? "true" : "false");
            this.n.setProperty("disabled", this.b.disabled);
        }
        ag() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("display", this.b.gc);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("display", this.b.gc);
                    let display_ = this.b.gc;
                    comp_.display = display_;
                }
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        ab() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("align-items", this.b.fw);
                this.n.setStyleProperty("align-items", this.b.fw);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("align-items", this.b.fw);
                    let alignItems_ = this.b.fw;
                    comp_.alignItems = alignItems_;
                }
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        ah() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-direction", this.b.hf);
                this.n.setStyleProperty("flex-direction", this.b.hf);
                let ext_ = this.k.getExternal(this.b, null, null);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("flex-direction", this.b.hf);
                    let direction_ = this.b.hf;
                    comp_.flexDirection = direction_;
                }
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        ai() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-grow", this.b.hh);
                this.n.setStyleProperty("flex-grow", this.b.hh);
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        s(a) {
        }
        ap() {
            if (this.g()) {
                let a = this.b.h8;
                this.n.setAttribute("name", this.b.ih);
                this.n.setProperty("value", this.b.e0);
                if (this.b.ah) {
                    this.n.setAttribute("tabindex", this.b.eu.toString());
                }
                this.n.setProperty("disabled", this.b.disabled);
                {
                }
                this.n.setAttribute("aria-label", this.b.fy);
            }
        }
        ak() {
            if (this.g()) {
                let a = this.b.h8;
                this.n.setAttribute("id", a);
            }
        }
        t(a) {
            this.b.jw();
        }
        u(a) {
            this.b.jx();
        }
        v(a) {
            this.b.js();
        }
        y(a) {
            this.b.jv();
        }
        x(a) {
            this.b.jt();
        }
        f() {
            return false;
        }
        w(a) {
        }
        aa() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.k;
            }
        }
        ac() {
            this.e = true;
            this.h.add(this.n.listen("change", runOn(this, this.w)));
            this.h.add(this.n.listen("click", runOn(this, this.x)));
            this.h.add(this.n.listen("focus", runOn(this, this.y)));
            this.h.add(this.n.listen("blur", runOn(this, this.v)));
            this.h.add(this.m.listen("click", runOn(this, this.s)));
            this.h.add(this.n.listen("mouseenter", runOn(this, this.t)));
            this.h.add(this.n.listen("mouseleave", runOn(this, this.u)));
        }
        ae() {
            this.e = false;
            for (let a of fromEnum(this.h)) {
                a();
            }
            this.h.clear();
        }
        am() {
            let model_ = this.b;
            if (model_.externalObject && model_.externalObject.refreshDefaults) {
                model_.externalObject.refreshDefaults();
            }
            ;
        }
        aq(a, b) {
            this.c.ax = a;
            this.c.aw = b;
        }
        ar(a, b) {
            let c = ElevationHelper.e(a, this.b.nk, this.b.nh, this.b.m7, b);
            this.n.setStyleProperty("box-shadow", c);
        }
        at(a) {
            if (a != null) {
                this.m.setStyleProperty("font", a.fontString);
            }
        }
        z(a) {
            this.m.append(a);
        }
        a() {
            let rect_ = this.k.rootWrapper.getNativeElement().getBoundingClientRect();
            let a = (rect_.top);
            let b = (rect_.left);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
    }
    ButtonView.$t = /*@__PURE__*/ markType(ButtonView, 'ButtonView');
    return ButtonView;
})();
/**
 * @hidden
 */
export let XButton = /*@__PURE__*/ (() => {
    class XButton extends Base {
        constructor() {
            super();
            this._view = null;
            this.ez = null;
            this.sg = ThemeResolver.e(XButton.h, XButton.rs, XButton.o9);
            this.r4 = ThemeResolver.e(XButton.h, XButton.rg, XButton.ox);
            this.nn = ThemeResolver.e(XButton.h, XButton.p7, XButton.no);
            this.r = ThemeResolver.a(XButton.h, XButton.s, XButton.q);
            this.r7 = ThemeResolver.e(XButton.h, XButton.rj, XButton.o0);
            this.r8 = ThemeResolver.e(XButton.h, XButton.rk, XButton.o1);
            this.r9 = ThemeResolver.e(XButton.h, XButton.rl, XButton.o2);
            this.d2 = ThemeResolver.c(XButton.h, XButton.du, XButton.cx);
            this.d5 = ThemeResolver.c(XButton.h, XButton.dx, XButton.c0);
            this.d4 = ThemeResolver.c(XButton.h, XButton.dw, XButton.cz);
            this.d3 = ThemeResolver.c(XButton.h, XButton.dv, XButton.cy);
            this.r6 = ThemeResolver.e(XButton.h, XButton.ri, XButton.oz);
            this.se = ThemeResolver.e(XButton.h, XButton.rq, XButton.o7);
            this.kt = ThemeResolver.d(XButton.h, XButton.kr, XButton.kj);
            this.bc = ThemeResolver.b(XButton.h, XButton.ba, XButton.a2);
            this.r5 = ThemeResolver.e(XButton.h, XButton.rh, XButton.oy);
            this.sf = ThemeResolver.e(XButton.h, XButton.rr, XButton.o8);
            this.sd = ThemeResolver.e(XButton.h, XButton.rp, XButton.o6);
            this.sc = ThemeResolver.e(XButton.h, XButton.ro, XButton.o5);
            this.sa = ThemeResolver.e(XButton.h, XButton.rm, XButton.o3);
            this.sb = ThemeResolver.e(XButton.h, XButton.rn, XButton.o4);
            this.pn = ThemeResolver.e(XButton.h, XButton.ql, XButton.n2);
            this.po = ThemeResolver.e(XButton.h, XButton.qm, XButton.n3);
            this.pp = ThemeResolver.e(XButton.h, XButton.qn, XButton.n4);
            this.c5 = ThemeResolver.c(XButton.h, XButton.dh, XButton.cl);
            this.c8 = ThemeResolver.c(XButton.h, XButton.dk, XButton.co);
            this.c7 = ThemeResolver.c(XButton.h, XButton.dj, XButton.cn);
            this.c6 = ThemeResolver.c(XButton.h, XButton.di, XButton.cm);
            this.pm = ThemeResolver.e(XButton.h, XButton.qk, XButton.n1);
            this.pu = ThemeResolver.e(XButton.h, XButton.qs, XButton.n9);
            this.kl = ThemeResolver.d(XButton.h, XButton.ko, XButton.kg);
            this.a4 = ThemeResolver.b(XButton.h, XButton.a7, XButton.az);
            this.pl = ThemeResolver.e(XButton.h, XButton.qj, XButton.n0);
            this.pv = ThemeResolver.e(XButton.h, XButton.qt, XButton.oa);
            this.pt = ThemeResolver.e(XButton.h, XButton.qr, XButton.n8);
            this.ps = ThemeResolver.e(XButton.h, XButton.qq, XButton.n7);
            this.pq = ThemeResolver.e(XButton.h, XButton.qo, XButton.n5);
            this.pr = ThemeResolver.e(XButton.h, XButton.qp, XButton.n6);
            this.rv = ThemeResolver.e(XButton.h, XButton.q7, XButton.oo);
            this.rw = ThemeResolver.e(XButton.h, XButton.q8, XButton.op);
            this.rx = ThemeResolver.e(XButton.h, XButton.q9, XButton.oq);
            this.dy = ThemeResolver.c(XButton.h, XButton.dq, XButton.ct);
            this.d1 = ThemeResolver.c(XButton.h, XButton.dt, XButton.cw);
            this.d0 = ThemeResolver.c(XButton.h, XButton.ds, XButton.cv);
            this.dz = ThemeResolver.c(XButton.h, XButton.dr, XButton.cu);
            this.ru = ThemeResolver.e(XButton.h, XButton.q6, XButton.on);
            this.r2 = ThemeResolver.e(XButton.h, XButton.re, XButton.ov);
            this.ks = ThemeResolver.d(XButton.h, XButton.kq, XButton.ki);
            this.bb = ThemeResolver.b(XButton.h, XButton.a9, XButton.a1);
            this.rt = ThemeResolver.e(XButton.h, XButton.q5, XButton.om);
            this.r3 = ThemeResolver.e(XButton.h, XButton.rf, XButton.ow);
            this.r1 = ThemeResolver.e(XButton.h, XButton.rd, XButton.ou);
            this.r0 = ThemeResolver.e(XButton.h, XButton.rc, XButton.ot);
            this.ry = ThemeResolver.e(XButton.h, XButton.ra, XButton.or);
            this.rz = ThemeResolver.e(XButton.h, XButton.rb, XButton.os);
            this.py = ThemeResolver.e(XButton.h, XButton.qw, XButton.od);
            this.pz = ThemeResolver.e(XButton.h, XButton.qx, XButton.oe);
            this.p0 = ThemeResolver.e(XButton.h, XButton.qy, XButton.of);
            this.c9 = ThemeResolver.c(XButton.h, XButton.dl, XButton.cp);
            this.dc = ThemeResolver.c(XButton.h, XButton.dp, XButton.cs);
            this.db = ThemeResolver.c(XButton.h, XButton.dn, XButton.cr);
            this.da = ThemeResolver.c(XButton.h, XButton.dm, XButton.cq);
            this.px = ThemeResolver.e(XButton.h, XButton.qv, XButton.oc);
            this.p5 = ThemeResolver.e(XButton.h, XButton.q3, XButton.ok);
            this.km = ThemeResolver.d(XButton.h, XButton.kp, XButton.kh);
            this.a5 = ThemeResolver.b(XButton.h, XButton.a8, XButton.a0);
            this.pw = ThemeResolver.e(XButton.h, XButton.qu, XButton.ob);
            this.p6 = ThemeResolver.e(XButton.h, XButton.q4, XButton.ol);
            this.p4 = ThemeResolver.e(XButton.h, XButton.q2, XButton.oj);
            this.p3 = ThemeResolver.e(XButton.h, XButton.q1, XButton.oi);
            this.p1 = ThemeResolver.e(XButton.h, XButton.qz, XButton.og);
            this.p2 = ThemeResolver.e(XButton.h, XButton.q0, XButton.oh);
            this.pc = ThemeResolver.e(XButton.h, XButton.qa, XButton.nr);
            this.pd = ThemeResolver.e(XButton.h, XButton.qb, XButton.ns);
            this.pe = ThemeResolver.e(XButton.h, XButton.qc, XButton.nt);
            this.c1 = ThemeResolver.c(XButton.h, XButton.dd, XButton.ch);
            this.c4 = ThemeResolver.c(XButton.h, XButton.dg, XButton.ck);
            this.c3 = ThemeResolver.c(XButton.h, XButton.df, XButton.cj);
            this.c2 = ThemeResolver.c(XButton.h, XButton.de, XButton.ci);
            this.pb = ThemeResolver.e(XButton.h, XButton.p9, XButton.nq);
            this.pj = ThemeResolver.e(XButton.h, XButton.qh, XButton.ny);
            this.kk = ThemeResolver.d(XButton.h, XButton.kn, XButton.kf);
            this.a3 = ThemeResolver.b(XButton.h, XButton.a6, XButton.ay);
            this.pa = ThemeResolver.e(XButton.h, XButton.p8, XButton.np);
            this.pk = ThemeResolver.e(XButton.h, XButton.qi, XButton.nz);
            this.pi = ThemeResolver.e(XButton.h, XButton.qg, XButton.nx);
            this.ph = ThemeResolver.e(XButton.h, XButton.qf, XButton.nw);
            this.pf = ThemeResolver.e(XButton.h, XButton.qd, XButton.nu);
            this.pg = ThemeResolver.e(XButton.h, XButton.qe, XButton.nv);
            this.at = NaN;
            this.as = NaN;
            this.d = 0;
            this.k = 0;
            this.g = 0;
            this.j = 1;
            this.k1 = ThemeResolver.e(XButton.h, XButton.ri, XButton.oz);
            this.lc = ThemeResolver.e(XButton.h, XButton.rs, XButton.o9);
            this.k9 = ThemeResolver.e(XButton.h, XButton.rg, XButton.ox);
            this.kz = ThemeResolver.e(XButton.h, XButton.p7, XButton.no);
            this.bn = ThemeResolver.c(XButton.h, XButton.dx, XButton.c0);
            this.bl = ThemeResolver.c(XButton.h, XButton.dv, XButton.cy);
            this.bm = ThemeResolver.c(XButton.h, XButton.dw, XButton.cz);
            this.la = ThemeResolver.e(XButton.h, XButton.rq, XButton.o7);
            this.j5 = ThemeResolver.d(XButton.h, XButton.kr, XButton.kj);
            this.k0 = ThemeResolver.e(XButton.h, XButton.rh, XButton.oy);
            this.k2 = ThemeResolver.e(XButton.h, XButton.rj, XButton.o0);
            this.k3 = ThemeResolver.e(XButton.h, XButton.rk, XButton.o1);
            this.k4 = ThemeResolver.e(XButton.h, XButton.rl, XButton.o2);
            this.bk = ThemeResolver.c(XButton.h, XButton.du, XButton.cx);
            this.n = ThemeResolver.a(XButton.h, XButton.s, XButton.q);
            this.lb = ThemeResolver.e(XButton.h, XButton.rr, XButton.o8);
            this.k8 = ThemeResolver.e(XButton.h, XButton.rp, XButton.o6);
            this.k5 = ThemeResolver.e(XButton.h, XButton.rm, XButton.o3);
            this.k6 = ThemeResolver.e(XButton.h, XButton.rn, XButton.o4);
            this.k7 = ThemeResolver.e(XButton.h, XButton.ro, XButton.o5);
            this.an = ThemeResolver.b(XButton.h, XButton.ba, XButton.a2);
            this.mu = null;
            this.mw = null;
            this.mx = null;
            this.my = null;
            this.b7 = -1;
            this.m1 = null;
            this.mv = null;
            this.ca = -1;
            this.b9 = -1;
            this.b8 = -1;
            this.av = NaN;
            this.kb = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.m3 = null;
            this.ls = null;
            this.lu = null;
            this.lv = null;
            this.lw = null;
            this.bt = -1;
            this.lz = null;
            this.lt = null;
            this.bw = -1;
            this.bv = -1;
            this.bu = -1;
            this.l1 = null;
            this.l2 = null;
            this.l0 = null;
            this.lx = null;
            this.ly = null;
            this.aq = NaN;
            this.j8 = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.ld = null;
            this.lf = null;
            this.lg = null;
            this.lh = null;
            this.bo = -1;
            this.o = 0;
            this.l5 = null;
            this.le = null;
            this.cb = -1;
            this.by = -1;
            this.bx = -1;
            this.u = null;
            this.m6 = null;
            this.l7 = null;
            this.m5 = null;
            this.m4 = null;
            this.m2 = null;
            this.mz = null;
            this.m0 = null;
            this.l3 = null;
            this.l4 = null;
            this.ao = NaN;
            this.j6 = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mj = null;
            this.ml = null;
            this.mm = null;
            this.mn = null;
            this.b3 = -1;
            this.mq = null;
            this.mk = null;
            this.b6 = -1;
            this.b5 = -1;
            this.b4 = -1;
            this.au = NaN;
            this.ka = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.ms = null;
            this.mt = null;
            this.mr = null;
            this.mo = null;
            this.mp = null;
            this.li = null;
            this.lk = null;
            this.ll = null;
            this.lm = null;
            this.bp = -1;
            this.l6 = null;
            this.lj = null;
            this.bs = -1;
            this.br = -1;
            this.bq = -1;
            this.ap = NaN;
            this.j7 = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.lq = null;
            this.lr = null;
            this.lp = null;
            this.ln = null;
            this.lo = null;
            this.l8 = null;
            this.ma = null;
            this.mb = null;
            this.mc = null;
            this.bz = -1;
            this.mf = null;
            this.l9 = null;
            this.b2 = -1;
            this.b1 = -1;
            this.b0 = -1;
            this.ar = NaN;
            this.j9 = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mh = null;
            this.mi = null;
            this.mg = null;
            this.md = null;
            this.me = null;
            this.e7 = "ig-native-button-" + XButton.ew++;
            this.e6 = "ig-button-" + XButton.ev++;
            this.e3 = "inline-block";
            this.e4 = "inline-block";
            this.e5 = null;
            this.e1 = "center";
            this.ex = null;
            this.e8 = null;
            this.cc = 0;
            this.z = false;
            this.e2 = null;
            this.ab = false;
            this.ac = true;
            this.x = false;
            this.w = false;
            this.ad = false;
            this.aa = false;
            this.y = false;
            this.propertyChanged = null;
            this.clicked = null;
            let a = new ButtonView();
            a.b = this;
            this.view = a;
            this.view.aj();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        jy(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.j0(a, b, c);
        }
        j0(a, b, c) {
            switch (a) {
                case "CornerRadius":
                case "BorderColor":
                case "RestingElevation":
                case "HoverElevation":
                case "FocusElevation":
                case "RippleColor":
                case "BorderWidth":
                case "BackgroundColor":
                case "DisabledBackgroundColor":
                case "DisabledBorderColor":
                case "DisabledTextColor":
                case "DisabledElevation":
                case "HoverBackgroundColor":
                case "TextStyle":
                case "FocusTextColor":
                case "TextColor":
                case "HoverTextColor":
                case "FocusBackgroundColor":
                case "RaisedBorderColor":
                case "RaisedRestingElevation":
                case "RaisedFocusElevation":
                case "RaisedHoverElevation":
                case "RaisedRippleColor":
                case "RaisedBorderWidth":
                case "RaisedBackgroundColor":
                case "RaisedDisabledBackgroundColor":
                case "RaisedDisabledBorderColor":
                case "RaisedDisabledTextColor":
                case "RaisedDisabledElevation":
                case "RaisedHoverBackgroundColor":
                case "RaisedCornerRadius":
                case "RaisedFocusBackgroundColor":
                case "RaisedFocusTextColor":
                case "RaisedTextColor":
                case "RaisedHoverTextColor":
                case "FlatBorderColor":
                case "FlatRestingElevation":
                case "FlatFocusElevation":
                case "FlatHoverElevation":
                case "FlatRippleColor":
                case "FlatBorderWidth":
                case "FlatBackgroundColor":
                case "FlatDisabledBackgroundColor":
                case "FlatDisabledBorderColor":
                case "FlatDisabledTextColor":
                case "FlatDisabledElevation":
                case "FlatHoverBackgroundColor":
                case "FlatCornerRadius":
                case "FlatFocusBackgroundColor":
                case "FlatFocusTextColor":
                case "FlatTextColor":
                case "FlatHoverTextColor":
                case "OutlinedRippleColor":
                case "OutlinedRestingElevation":
                case "OutlinedFocusElevation":
                case "OutlinedHoverElevation":
                case "OutlinedBorderColor":
                case "OutlinedBorderWidth":
                case "OutlinedBackgroundColor":
                case "OutlinedDisabledBackgroundColor":
                case "OutlinedDisabledBorderColor":
                case "OutlinedDisabledTextColor":
                case "OutlinedDisabledElevation":
                case "OutlinedHoverBackgroundColor":
                case "OutlinedCornerRadius":
                case "OutlinedFocusBackgroundColor":
                case "OutlinedFocusTextColor":
                case "OutlinedTextColor":
                case "OutlinedHoverTextColor":
                case "FabBorderColor":
                case "FabRippleColor":
                case "FabRestingElevation":
                case "FabFocusElevation":
                case "FabHoverElevation":
                case "FabBorderWidth":
                case "FabBackgroundColor":
                case "FabDisabledBackgroundColor":
                case "FabDisabledBorderColor":
                case "FabDisabledTextColor":
                case "FabDisabledElevation":
                case "FabHoverBackgroundColor":
                case "FabCornerRadius":
                case "FabFocusBackgroundColor":
                case "FabFocusTextColor":
                case "FabTextColor":
                case "FabHoverTextColor":
                case "IconRestingElevation":
                case "IconFocusElevation":
                case "IconHoverElevation":
                case "IconBorderColor":
                case "IconRippleColor":
                case "IconBorderWidth":
                case "IconBackgroundColor":
                case "IconDisabledBackgroundColor":
                case "IconDisabledBorderColor":
                case "IconDisabledTextColor":
                case "IconDisabledElevation":
                case "IconHoverBackgroundColor":
                case "IconCornerRadius":
                case "IconFocusBackgroundColor":
                case "IconFocusTextColor":
                case "IconTextColor":
                case "IconHoverTextColor":
                case "ElevationMode":
                    this.j3();
                    break;
                case "BaseTheme":
                    this.j4(this.i == 0 ? 2 : this.i);
                    this.j3();
                    break;
                case "IsDisabled":
                    this.ae = this.disabled || this.af;
                    this.j3();
                    this.view.al();
                    break;
                case "DisableRipple":
                    this.ae = this.disabled || this.af;
                    this.j3();
                    break;
                case "ActualDisableRipple":
                    this.view.af();
                    break;
                case "ActualBackgroundColor":
                case "ActualDisabledBackgroundColor":
                case "ActualDisabledBorderColor":
                case "ActualDisabledTextColor":
                case "ActualDisabledElevation":
                case "ActualHoverBackgroundColor":
                case "ActualBorderColor":
                case "ActualFocusTextColor":
                case "ActualHoverTextColor":
                case "ActualElevationMode":
                    this.j2();
                    break;
                case "Density":
                    this.l = this.m == 0 ? 1 : this.m;
                    break;
                case "ActualDensity":
                case "ActualBorderWidth":
                case "ActualCornerRadius":
                    this.view.as();
                    this.j2();
                    break;
                case "DisplayType":
                    this.view.as();
                    this.j3();
                    this.j2();
                    break;
                case "InputId":
                    this.view.ak();
                    break;
                case "Display":
                    this.view.ag();
                    break;
                case "FlexDirection":
                    this.view.ah();
                    break;
                case "FlexGrow":
                    this.view.ai();
                    break;
                case "AlignItems":
                    this.view.ab();
                    break;
                case "TabIndex":
                    this.view.ap();
                    break;
                case "MinWidth":
                    this.view.ao(this.bh);
                    this.view.as();
                    break;
                case "MinHeight":
                    this.view.an(this.bg);
                    this.view.as();
                    break;
            }
        }
        kd(a, b) {
            return new CornerRadius(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b, !isNaN_(a.a) ? a.a : b.a);
        }
        j3() {
            this.p = this.t != 0 ? this.t : this.r;
            this.nk = this.sg;
            this.nh = this.r4;
            this.m7 = this.nn;
            switch (this.e) {
                case 0:
                    this.na = this.sh != null ? this.sh : this.ty != null ? this.ty : this.r7;
                    this.nb = this.si != null ? this.si : this.tz != null ? this.tz : this.r8;
                    this.nc = this.sj != null ? this.sj : this.t0 != null ? this.t0 : this.r9;
                    this.cd = this.d6 >= 0 ? this.d6 : this.ep >= 0 ? this.ep : this.d2;
                    this.cg = this.et >= 0 ? this.et : this.es >= 0 ? this.es : this.d5;
                    this.cf = this.eg >= 0 ? this.eg : this.er >= 0 ? this.er : this.d4;
                    this.ce = this.ef >= 0 ? this.ef : this.eq >= 0 ? this.eq : this.d3;
                    this.m9 = this.nm != null ? this.nm : this.tx != null ? this.tx : this.r6;
                    this.m8 = this.nl != null ? this.nl : this.tw != null ? this.tw : this.r5;
                    this.nf = this.s8 != null ? this.s8 : this.t3 != null ? this.t3 : this.sc;
                    this.kc = this.kd(this.ke, this.kd(this.ky, this.kt));
                    this.aw = !isNaN_(this.ax) ? this.ax : !isNaN_(this.bj) ? this.bj : this.bc;
                    this.ni = this.t7 != null ? this.t7 : this.t5 != null ? this.t5 : this.se;
                    this.nd = this.s6 != null ? this.s6 : this.t1 != null ? this.t1 : this.sa;
                    this.ne = this.s7 != null ? this.s7 : this.t2 != null ? this.t2 : this.sb;
                    this.nj = this.t8 != null ? this.t8 : this.t6 != null ? this.t6 : this.sf;
                    this.ng = this.s9 != null ? this.s9 : this.t4 != null ? this.t4 : this.sd;
                    break;
                case 2:
                    this.na = this.sh != null ? this.sh : this.tn != null ? this.tn : this.rv;
                    this.nb = this.si != null ? this.si : this.to != null ? this.to : this.rw;
                    this.nc = this.sj != null ? this.sj : this.tp != null ? this.tp : this.rx;
                    this.cd = this.d6 >= 0 ? this.d6 : this.el >= 0 ? this.el : this.dy;
                    this.cg = this.et >= 0 ? this.et : this.eo >= 0 ? this.eo : this.d1;
                    this.cf = this.eg >= 0 ? this.eg : this.en >= 0 ? this.en : this.d0;
                    this.ce = this.ef >= 0 ? this.ef : this.em >= 0 ? this.em : this.dz;
                    this.m9 = this.nm != null ? this.nm : this.tm != null ? this.tm : this.ru;
                    this.m8 = this.s8 != null ? this.s8 : this.nl != null ? this.nl : this.tl != null ? this.tl : this.rt;
                    this.nf = this.ts != null ? this.ts : this.r0;
                    this.kc = this.kd(this.ke, this.kd(this.kx, this.ks));
                    this.aw = !isNaN_(this.ax) ? this.ax : !isNaN_(this.bi) ? this.bi : this.bb;
                    this.ni = this.t7 != null ? this.t7 : this.tu != null ? this.tu : this.r2;
                    this.nd = this.s6 != null ? this.s6 : this.tq != null ? this.tq : this.ry;
                    this.ne = this.s7 != null ? this.s7 : this.tr != null ? this.tr : this.rz;
                    this.nj = this.t8 != null ? this.t8 : this.tv != null ? this.tv : this.r3;
                    this.ng = this.s9 != null ? this.s9 : this.tt != null ? this.tt : this.r1;
                    break;
                case 1:
                    this.na = this.sh != null ? this.sh : this.sx != null ? this.sx : this.pn;
                    this.nb = this.si != null ? this.si : this.sy != null ? this.sy : this.po;
                    this.nc = this.sj != null ? this.sj : this.sz != null ? this.sz : this.pp;
                    this.cd = this.d6 >= 0 ? this.d6 : this.eb >= 0 ? this.eb : this.c5;
                    this.cg = this.et >= 0 ? this.et : this.ee >= 0 ? this.ee : this.c8;
                    this.cf = this.eg >= 0 ? this.eg : this.ed >= 0 ? this.ed : this.c7;
                    this.ce = this.ef >= 0 ? this.ef : this.ec >= 0 ? this.ec : this.c6;
                    this.m9 = this.nm != null ? this.nm : this.sw != null ? this.sw : this.pm;
                    this.m8 = this.nl != null ? this.nl : this.sv != null ? this.sv : this.pl;
                    this.nf = this.s8 != null ? this.s8 : this.s2 != null ? this.s2 : this.ps;
                    this.kc = this.kd(this.ke, this.kd(this.kv, this.kl));
                    this.aw = !isNaN_(this.ax) ? this.ax : !isNaN_(this.be) ? this.be : this.a4;
                    this.ni = this.t7 != null ? this.t7 : this.s4 != null ? this.s4 : this.pu;
                    this.nd = this.s6 != null ? this.s6 : this.s0 != null ? this.s0 : this.pq;
                    this.ne = this.s7 != null ? this.s7 : this.s1 != null ? this.s1 : this.pr;
                    this.nj = this.t8 != null ? this.t8 : this.s5 != null ? this.s5 : this.pv;
                    this.ng = this.s9 != null ? this.s9 : this.s3 != null ? this.s3 : this.pt;
                    break;
                case 4:
                    this.na = this.sh != null ? this.sh : this.tc != null ? this.tc : this.py;
                    this.nb = this.si != null ? this.si : this.td != null ? this.td : this.pz;
                    this.nc = this.sj != null ? this.sj : this.te != null ? this.te : this.p0;
                    this.cd = this.d6 >= 0 ? this.d6 : this.eh >= 0 ? this.eh : this.c9;
                    this.cg = this.et >= 0 ? this.et : this.ek >= 0 ? this.ek : this.dc;
                    this.cf = this.eg >= 0 ? this.eg : this.ej >= 0 ? this.ej : this.db;
                    this.ce = this.ef >= 0 ? this.ef : this.ei >= 0 ? this.ei : this.da;
                    this.m9 = this.nm != null ? this.nm : this.tb != null ? this.tb : this.px;
                    this.m8 = this.nl != null ? this.nl : this.ta != null ? this.ta : this.pw;
                    this.nf = this.s8 != null ? this.s8 : this.th != null ? this.th : this.p3;
                    this.kc = this.kd(this.ke, this.kd(this.kw, this.km));
                    this.aw = !isNaN_(this.ax) ? this.ax : !isNaN_(this.bf) ? this.bf : this.a5;
                    this.ni = this.t7 != null ? this.t7 : this.tj != null ? this.tj : this.p5;
                    this.nd = this.s6 != null ? this.s6 : this.tf != null ? this.tf : this.p1;
                    this.ne = this.s7 != null ? this.s7 : this.tg != null ? this.tg : this.p2;
                    this.nj = this.t8 != null ? this.t8 : this.tk != null ? this.tk : this.p6;
                    this.ng = this.s9 != null ? this.s9 : this.ti != null ? this.ti : this.p4;
                    break;
                case 3:
                    this.na = this.sh != null ? this.sh : this.sm != null ? this.sm : this.pc;
                    this.nb = this.si != null ? this.si : this.sn != null ? this.sn : this.pd;
                    this.nc = this.sj != null ? this.sj : this.so != null ? this.so : this.pe;
                    this.cd = this.d6 >= 0 ? this.d6 : this.d7 >= 0 ? this.d7 : this.c1;
                    this.cg = this.et >= 0 ? this.et : this.ea >= 0 ? this.ea : this.c4;
                    this.cf = this.eg >= 0 ? this.eg : this.d9 >= 0 ? this.d9 : this.c3;
                    this.ce = this.ef >= 0 ? this.ef : this.d8 >= 0 ? this.d8 : this.c2;
                    this.m9 = this.nm != null ? this.nm : this.sl != null ? this.sl : this.pb;
                    this.m8 = this.nl != null ? this.nl : this.sk != null ? this.sk : this.pa;
                    this.nf = this.s8 != null ? this.s8 : this.sr != null ? this.sr : this.ph;
                    this.kc = this.kd(this.ke, this.kd(this.ku, this.kk));
                    this.aw = !isNaN_(this.ax) ? this.ax : !isNaN_(this.bd) ? this.bd : this.a3;
                    this.ni = this.t7 != null ? this.t7 : this.st != null ? this.st : this.se;
                    this.nd = this.s6 != null ? this.s6 : this.sp != null ? this.sp : this.pf;
                    this.ne = this.s7 != null ? this.s7 : this.sq != null ? this.sq : this.pg;
                    this.nj = this.t8 != null ? this.t8 : this.su != null ? this.su : this.pk;
                    this.ng = this.s9 != null ? this.s9 : this.ss != null ? this.ss : this.pi;
                    break;
            }
        }
        jt() {
            if (this.disabled) {
                return;
            }
            if (this.clicked != null) {
                this.clicked(this, new ButtonClickEventArgs());
            }
        }
        js() {
            this.focused = false;
            this.j2();
        }
        jv() {
            this.focused = true;
            this.j2();
        }
        jx() {
            this.al = false;
            this.j2();
        }
        jw() {
            this.al = true;
            this.j2();
        }
        j2() {
            let a = this.view.q;
            if (a == null) {
                return;
            }
            NativeUI.m(a, this.kc);
            NativeUI.l(a, this.m9);
            if (!isNaN_(this.aw)) {
                NativeUI.n(a, new Thickness(0, this.aw));
            }
            if (this.disabled) {
                this.view.ar(this.cd, this.p);
            }
            else if (this.focused && this.ak) {
                this.view.ar(this.ce, this.p);
            }
            else {
                if (this.al) {
                    this.view.ar(this.cf, this.p);
                }
                else {
                    this.view.ar(this.cg, this.p);
                }
            }
            if (this.disabled) {
                NativeUI.k(a, this.na);
            }
            else if (this.focused && this.ak) {
                NativeUI.k(a, this.nd);
            }
            else {
                if (this.al) {
                    NativeUI.k(a, this.nf);
                }
                else {
                    NativeUI.k(a, this.m8);
                }
            }
            this.view.aq(this.ni, BrushUtil.g(0, 0, 0, 0));
            if (this.v != null) {
                this.view.at(this.v);
            }
            if (this.disabled) {
                NativeUI.o(this.view.r, this.nc);
                NativeUI.p(this.view.r, this.nc);
            }
            else if (this.focused && this.ak) {
                NativeUI.o(this.view.r, this.ne);
                NativeUI.p(this.view.r, this.ne);
            }
            else {
                if (this.al) {
                    NativeUI.o(this.view.r, this.ng);
                    NativeUI.p(this.view.r, this.ng);
                }
                else {
                    NativeUI.o(this.view.r, this.nj);
                    NativeUI.p(this.view.r, this.nj);
                }
            }
        }
        j4(a) {
            this.sg = ThemeResolver.e(a, XButton.rs, XButton.o9);
            this.r4 = ThemeResolver.e(a, XButton.rg, XButton.ox);
            this.nn = ThemeResolver.e(a, XButton.p7, XButton.no);
            this.r = ThemeResolver.a(a, XButton.s, XButton.q);
            this.r7 = ThemeResolver.e(a, XButton.rj, XButton.o0);
            this.r8 = ThemeResolver.e(a, XButton.rk, XButton.o1);
            this.r9 = ThemeResolver.e(a, XButton.rl, XButton.o2);
            this.d2 = ThemeResolver.c(a, XButton.du, XButton.cx);
            this.d5 = ThemeResolver.c(a, XButton.dx, XButton.c0);
            this.d4 = ThemeResolver.c(a, XButton.dw, XButton.cz);
            this.d3 = ThemeResolver.c(a, XButton.dv, XButton.cy);
            this.r6 = ThemeResolver.e(a, XButton.ri, XButton.oz);
            this.se = ThemeResolver.e(a, XButton.rq, XButton.o7);
            this.kt = ThemeResolver.d(a, XButton.kr, XButton.kj);
            this.bc = ThemeResolver.b(a, XButton.ba, XButton.a2);
            this.r5 = ThemeResolver.e(a, XButton.rh, XButton.oy);
            this.sf = ThemeResolver.e(a, XButton.rr, XButton.o8);
            this.sd = ThemeResolver.e(a, XButton.rp, XButton.o6);
            this.sc = ThemeResolver.e(a, XButton.ro, XButton.o5);
            this.sa = ThemeResolver.e(a, XButton.rm, XButton.o3);
            this.sb = ThemeResolver.e(a, XButton.rn, XButton.o4);
            this.pn = ThemeResolver.e(a, XButton.ql, XButton.n2);
            this.po = ThemeResolver.e(a, XButton.qm, XButton.n3);
            this.pp = ThemeResolver.e(a, XButton.qn, XButton.n4);
            this.c5 = ThemeResolver.c(a, XButton.dh, XButton.cl);
            this.c8 = ThemeResolver.c(a, XButton.dk, XButton.co);
            this.c7 = ThemeResolver.c(a, XButton.dj, XButton.cn);
            this.c6 = ThemeResolver.c(a, XButton.di, XButton.cm);
            this.pm = ThemeResolver.e(a, XButton.qk, XButton.n1);
            this.pu = ThemeResolver.e(a, XButton.qs, XButton.n9);
            this.kl = ThemeResolver.d(a, XButton.ko, XButton.kg);
            this.a4 = ThemeResolver.b(a, XButton.a7, XButton.az);
            this.pl = ThemeResolver.e(a, XButton.qj, XButton.n0);
            this.pv = ThemeResolver.e(a, XButton.qt, XButton.oa);
            this.pt = ThemeResolver.e(a, XButton.qr, XButton.n8);
            this.ps = ThemeResolver.e(a, XButton.qq, XButton.n7);
            this.pq = ThemeResolver.e(a, XButton.qo, XButton.n5);
            this.pr = ThemeResolver.e(a, XButton.qp, XButton.n6);
            this.rv = ThemeResolver.e(a, XButton.q7, XButton.oo);
            this.rw = ThemeResolver.e(a, XButton.q8, XButton.op);
            this.rx = ThemeResolver.e(a, XButton.q9, XButton.oq);
            this.dy = ThemeResolver.c(a, XButton.dq, XButton.ct);
            this.d1 = ThemeResolver.c(a, XButton.dt, XButton.cw);
            this.d0 = ThemeResolver.c(a, XButton.ds, XButton.cv);
            this.dz = ThemeResolver.c(a, XButton.dr, XButton.cu);
            this.ru = ThemeResolver.e(a, XButton.q6, XButton.on);
            this.r2 = ThemeResolver.e(a, XButton.re, XButton.ov);
            this.ks = ThemeResolver.d(a, XButton.kq, XButton.ki);
            this.bb = ThemeResolver.b(a, XButton.a9, XButton.a1);
            this.rt = ThemeResolver.e(a, XButton.q5, XButton.om);
            this.r3 = ThemeResolver.e(a, XButton.rf, XButton.ow);
            this.r1 = ThemeResolver.e(a, XButton.rd, XButton.ou);
            this.r0 = ThemeResolver.e(a, XButton.rc, XButton.ot);
            this.ry = ThemeResolver.e(a, XButton.ra, XButton.or);
            this.rz = ThemeResolver.e(a, XButton.rb, XButton.os);
            this.py = ThemeResolver.e(a, XButton.qw, XButton.od);
            this.pz = ThemeResolver.e(a, XButton.qx, XButton.oe);
            this.p0 = ThemeResolver.e(a, XButton.qy, XButton.of);
            this.c9 = ThemeResolver.c(a, XButton.dl, XButton.cp);
            this.dc = ThemeResolver.c(a, XButton.dp, XButton.cs);
            this.db = ThemeResolver.c(a, XButton.dn, XButton.cr);
            this.da = ThemeResolver.c(a, XButton.dm, XButton.cq);
            this.px = ThemeResolver.e(a, XButton.qv, XButton.oc);
            this.p5 = ThemeResolver.e(a, XButton.q3, XButton.ok);
            this.km = ThemeResolver.d(a, XButton.kp, XButton.kh);
            this.a5 = ThemeResolver.b(a, XButton.a8, XButton.a0);
            this.pw = ThemeResolver.e(a, XButton.qu, XButton.ob);
            this.p6 = ThemeResolver.e(a, XButton.q4, XButton.ol);
            this.p4 = ThemeResolver.e(a, XButton.q2, XButton.oj);
            this.p3 = ThemeResolver.e(a, XButton.q1, XButton.oi);
            this.p1 = ThemeResolver.e(a, XButton.qz, XButton.og);
            this.p2 = ThemeResolver.e(a, XButton.q0, XButton.oh);
            this.pc = ThemeResolver.e(a, XButton.qa, XButton.nr);
            this.pd = ThemeResolver.e(a, XButton.qb, XButton.ns);
            this.pe = ThemeResolver.e(a, XButton.qc, XButton.nt);
            this.c1 = ThemeResolver.c(a, XButton.dd, XButton.ch);
            this.c4 = ThemeResolver.c(a, XButton.dg, XButton.ck);
            this.c3 = ThemeResolver.c(a, XButton.df, XButton.cj);
            this.c2 = ThemeResolver.c(a, XButton.de, XButton.ci);
            this.pb = ThemeResolver.e(a, XButton.p9, XButton.nq);
            this.pj = ThemeResolver.e(a, XButton.qh, XButton.ny);
            this.kk = ThemeResolver.d(a, XButton.kn, XButton.kf);
            this.a3 = ThemeResolver.b(a, XButton.a6, XButton.ay);
            this.pa = ThemeResolver.e(a, XButton.p8, XButton.np);
            this.pk = ThemeResolver.e(a, XButton.qi, XButton.nz);
            this.pi = ThemeResolver.e(a, XButton.qg, XButton.nx);
            this.ph = ThemeResolver.e(a, XButton.qf, XButton.nw);
            this.pf = ThemeResolver.e(a, XButton.qd, XButton.nu);
            this.pg = ThemeResolver.e(a, XButton.qe, XButton.nv);
        }
        get bh() {
            return this.at;
        }
        set bh(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.jy("MinWidth", b, a);
            }
        }
        get bg() {
            return this.as;
        }
        set bg(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.jy("MinHeight", b, a);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.jy("DisplayType", enumGetBox(ButtonDisplayStyle_$type, b), enumGetBox(ButtonDisplayStyle_$type, a));
            }
        }
        get m() {
            return this.k;
        }
        set m(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.jy("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get i() {
            return this.g;
        }
        set i(a) {
            let b = this.g;
            this.g = a;
            if (b != this.g) {
                this.jy("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get l() {
            return this.j;
        }
        set l(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.jy("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get m9() {
            return this.k1;
        }
        set m9(a) {
            let b = this.k1;
            this.k1 = a;
            if (b != this.k1) {
                this.jy("ActualBorderColor", b, a);
            }
        }
        get nk() {
            return this.lc;
        }
        set nk(a) {
            let b = this.lc;
            this.lc = a;
            if (b != this.lc) {
                this.jy("ActualUmbraShadowColor", b, a);
            }
        }
        get nh() {
            return this.k9;
        }
        set nh(a) {
            let b = this.k9;
            this.k9 = a;
            if (b != this.k9) {
                this.jy("ActualPenumbraShadowColor", b, a);
            }
        }
        get m7() {
            return this.kz;
        }
        set m7(a) {
            let b = this.kz;
            this.kz = a;
            if (b != this.kz) {
                this.jy("ActualAmbientShadowColor", b, a);
            }
        }
        get cg() {
            return this.bn;
        }
        set cg(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.jy("ActualRestingElevation", b, a);
            }
        }
        get ce() {
            return this.bl;
        }
        set ce(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.jy("ActualFocusElevation", b, a);
            }
        }
        get cf() {
            return this.bm;
        }
        set cf(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.jy("ActualHoverElevation", b, a);
            }
        }
        get ni() {
            return this.la;
        }
        set ni(a) {
            let b = this.la;
            this.la = a;
            if (b != this.la) {
                this.jy("ActualRippleColor", b, a);
            }
        }
        get kc() {
            return this.j5;
        }
        set kc(a) {
            let b = this.j5;
            this.j5 = a;
            if (b != this.j5) {
                this.jy("ActualCornerRadius", b, a);
            }
        }
        get m8() {
            return this.k0;
        }
        set m8(a) {
            let b = this.k0;
            this.k0 = a;
            if (b != this.k0) {
                this.jy("ActualBackgroundColor", b, a);
            }
        }
        get na() {
            return this.k2;
        }
        set na(a) {
            let b = this.k2;
            this.k2 = a;
            if (b != this.k2) {
                this.jy("ActualDisabledBackgroundColor", b, a);
            }
        }
        get nb() {
            return this.k3;
        }
        set nb(a) {
            let b = this.k3;
            this.k3 = a;
            if (b != this.k3) {
                this.jy("ActualDisabledBorderColor", b, a);
            }
        }
        get nc() {
            return this.k4;
        }
        set nc(a) {
            let b = this.k4;
            this.k4 = a;
            if (b != this.k4) {
                this.jy("ActualDisabledTextColor", b, a);
            }
        }
        get cd() {
            return this.bk;
        }
        set cd(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.jy("ActualDisabledElevation", b, a);
            }
        }
        get p() {
            return this.n;
        }
        set p(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.jy("ActualElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get nj() {
            return this.lb;
        }
        set nj(a) {
            let b = this.lb;
            this.lb = a;
            if (b != this.lb) {
                this.jy("ActualTextColor", b, a);
            }
        }
        get ng() {
            return this.k8;
        }
        set ng(a) {
            let b = this.k8;
            this.k8 = a;
            if (b != this.k8) {
                this.jy("ActualHoverTextColor", b, a);
            }
        }
        get nd() {
            return this.k5;
        }
        set nd(a) {
            let b = this.k5;
            this.k5 = a;
            if (b != this.k5) {
                this.jy("ActualFocusBackgroundColor", b, a);
            }
        }
        get ne() {
            return this.k6;
        }
        set ne(a) {
            let b = this.k6;
            this.k6 = a;
            if (b != this.k6) {
                this.jy("ActualFocusTextColor", b, a);
            }
        }
        get nf() {
            return this.k7;
        }
        set nf(a) {
            let b = this.k7;
            this.k7 = a;
            if (b != this.k7) {
                this.jy("ActualHoverBackgroundColor", b, a);
            }
        }
        get aw() {
            return this.an;
        }
        set aw(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.jy("ActualBorderWidth", b, a);
            }
        }
        get tw() {
            return this.mu;
        }
        set tw(a) {
            let b = this.mu;
            this.mu = a;
            if (b != this.mu) {
                this.jy("RaisedBackgroundColor", b, a);
            }
        }
        get ty() {
            return this.mw;
        }
        set ty(a) {
            let b = this.mw;
            this.mw = a;
            if (b != this.mw) {
                this.jy("RaisedDisabledBackgroundColor", b, a);
            }
        }
        get tz() {
            return this.mx;
        }
        set tz(a) {
            let b = this.mx;
            this.mx = a;
            if (b != this.mx) {
                this.jy("RaisedDisabledBorderColor", b, a);
            }
        }
        get t0() {
            return this.my;
        }
        set t0(a) {
            let b = this.my;
            this.my = a;
            if (b != this.my) {
                this.jy("RaisedDisabledTextColor", b, a);
            }
        }
        get ep() {
            return this.b7;
        }
        set ep(a) {
            let b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.jy("RaisedDisabledElevation", b, a);
            }
        }
        get t3() {
            return this.m1;
        }
        set t3(a) {
            let b = this.m1;
            this.m1 = a;
            if (b != this.m1) {
                this.jy("RaisedHoverBackgroundColor", b, a);
            }
        }
        get tx() {
            return this.mv;
        }
        set tx(a) {
            let b = this.mv;
            this.mv = a;
            if (b != this.mv) {
                this.jy("RaisedBorderColor", b, a);
            }
        }
        get es() {
            return this.ca;
        }
        set es(a) {
            let b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.jy("RaisedRestingElevation", b, a);
            }
        }
        get er() {
            return this.b9;
        }
        set er(a) {
            let b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.jy("RaisedHoverElevation", b, a);
            }
        }
        get eq() {
            return this.b8;
        }
        set eq(a) {
            let b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.jy("RaisedFocusElevation", b, a);
            }
        }
        get bj() {
            return this.av;
        }
        set bj(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.jy("RaisedBorderWidth", b, a);
            }
        }
        get ky() {
            return this.kb;
        }
        set ky(a) {
            let b = this.kb;
            this.kb = a;
            {
                this.jy("RaisedCornerRadius", b, a);
            }
        }
        get t5() {
            return this.m3;
        }
        set t5(a) {
            let b = this.m3;
            this.m3 = a;
            if (b != this.m3) {
                this.jy("RaisedRippleColor", b, a);
            }
        }
        get sv() {
            return this.ls;
        }
        set sv(a) {
            let b = this.ls;
            this.ls = a;
            if (b != this.ls) {
                this.jy("FlatBackgroundColor", b, a);
            }
        }
        get sx() {
            return this.lu;
        }
        set sx(a) {
            let b = this.lu;
            this.lu = a;
            if (b != this.lu) {
                this.jy("FlatDisabledBackgroundColor", b, a);
            }
        }
        get sy() {
            return this.lv;
        }
        set sy(a) {
            let b = this.lv;
            this.lv = a;
            if (b != this.lv) {
                this.jy("FlatDisabledBorderColor", b, a);
            }
        }
        get sz() {
            return this.lw;
        }
        set sz(a) {
            let b = this.lw;
            this.lw = a;
            if (b != this.lw) {
                this.jy("FlatDisabledTextColor", b, a);
            }
        }
        get eb() {
            return this.bt;
        }
        set eb(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.jy("FlatDisabledElevation", b, a);
            }
        }
        get s2() {
            return this.lz;
        }
        set s2(a) {
            let b = this.lz;
            this.lz = a;
            if (b != this.lz) {
                this.jy("FlatHoverBackgroundColor", b, a);
            }
        }
        get sw() {
            return this.lt;
        }
        set sw(a) {
            let b = this.lt;
            this.lt = a;
            if (b != this.lt) {
                this.jy("FlatBorderColor", b, a);
            }
        }
        get ee() {
            return this.bw;
        }
        set ee(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.jy("FlatRestingElevation", b, a);
            }
        }
        get ed() {
            return this.bv;
        }
        set ed(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.jy("FlatHoverElevation", b, a);
            }
        }
        get ec() {
            return this.bu;
        }
        set ec(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.jy("FlatFocusElevation", b, a);
            }
        }
        get s4() {
            return this.l1;
        }
        set s4(a) {
            let b = this.l1;
            this.l1 = a;
            if (b != this.l1) {
                this.jy("FlatRippleColor", b, a);
            }
        }
        get s5() {
            return this.l2;
        }
        set s5(a) {
            let b = this.l2;
            this.l2 = a;
            if (b != this.l2) {
                this.jy("FlatTextColor", b, a);
            }
        }
        get s3() {
            return this.l0;
        }
        set s3(a) {
            let b = this.l0;
            this.l0 = a;
            if (b != this.l0) {
                this.jy("FlatHoverTextColor", b, a);
            }
        }
        get s0() {
            return this.lx;
        }
        set s0(a) {
            let b = this.lx;
            this.lx = a;
            if (b != this.lx) {
                this.jy("FlatFocusBackgroundColor", b, a);
            }
        }
        get s1() {
            return this.ly;
        }
        set s1(a) {
            let b = this.ly;
            this.ly = a;
            if (b != this.ly) {
                this.jy("FlatFocusTextColor", b, a);
            }
        }
        get be() {
            return this.aq;
        }
        set be(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.jy("FlatBorderWidth", b, a);
            }
        }
        get kv() {
            return this.j8;
        }
        set kv(a) {
            let b = this.j8;
            this.j8 = a;
            {
                this.jy("FlatCornerRadius", b, a);
            }
        }
        get nl() {
            return this.ld;
        }
        set nl(a) {
            let b = this.ld;
            this.ld = a;
            if (b != this.ld) {
                this.jy("BackgroundColor", b, a);
            }
        }
        get sh() {
            return this.lf;
        }
        set sh(a) {
            let b = this.lf;
            this.lf = a;
            if (b != this.lf) {
                this.jy("DisabledBackgroundColor", b, a);
            }
        }
        get si() {
            return this.lg;
        }
        set si(a) {
            let b = this.lg;
            this.lg = a;
            if (b != this.lg) {
                this.jy("DisabledBorderColor", b, a);
            }
        }
        get sj() {
            return this.lh;
        }
        set sj(a) {
            let b = this.lh;
            this.lh = a;
            if (b != this.lh) {
                this.jy("DisabledTextColor", b, a);
            }
        }
        get d6() {
            return this.bo;
        }
        set d6(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.jy("DisabledElevation", b, a);
            }
        }
        get t() {
            return this.o;
        }
        set t(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.jy("ElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get s8() {
            return this.l5;
        }
        set s8(a) {
            let b = this.l5;
            this.l5 = a;
            if (b != this.l5) {
                this.jy("HoverBackgroundColor", b, a);
            }
        }
        get nm() {
            return this.le;
        }
        set nm(a) {
            let b = this.le;
            this.le = a;
            if (b != this.le) {
                this.jy("BorderColor", b, a);
            }
        }
        get et() {
            return this.cb;
        }
        set et(a) {
            let b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.jy("RestingElevation", b, a);
            }
        }
        get eg() {
            return this.by;
        }
        set eg(a) {
            let b = this.by;
            this.by = a;
            if (b != this.by) {
                this.jy("HoverElevation", b, a);
            }
        }
        get ef() {
            return this.bx;
        }
        set ef(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.jy("FocusElevation", b, a);
            }
        }
        get v() {
            return this.u;
        }
        set v(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.jy("TextStyle", b, a);
            }
        }
        get t8() {
            return this.m6;
        }
        set t8(a) {
            let b = this.m6;
            this.m6 = a;
            if (b != this.m6) {
                this.jy("TextColor", b, a);
            }
        }
        get s9() {
            return this.l7;
        }
        set s9(a) {
            let b = this.l7;
            this.l7 = a;
            if (b != this.l7) {
                this.jy("HoverTextColor", b, a);
            }
        }
        get t7() {
            return this.m5;
        }
        set t7(a) {
            let b = this.m5;
            this.m5 = a;
            if (b != this.m5) {
                this.jy("RippleColor", b, a);
            }
        }
        get t6() {
            return this.m4;
        }
        set t6(a) {
            let b = this.m4;
            this.m4 = a;
            if (b != this.m4) {
                this.jy("RaisedTextColor", b, a);
            }
        }
        get t4() {
            return this.m2;
        }
        set t4(a) {
            let b = this.m2;
            this.m2 = a;
            if (b != this.m2) {
                this.jy("RaisedHoverTextColor", b, a);
            }
        }
        get t1() {
            return this.mz;
        }
        set t1(a) {
            let b = this.mz;
            this.mz = a;
            if (b != this.mz) {
                this.jy("RaisedFocusBackgroundColor", b, a);
            }
        }
        get t2() {
            return this.m0;
        }
        set t2(a) {
            let b = this.m0;
            this.m0 = a;
            if (b != this.m0) {
                this.jy("RaisedFocusTextColor", b, a);
            }
        }
        get s6() {
            return this.l3;
        }
        set s6(a) {
            let b = this.l3;
            this.l3 = a;
            if (b != this.l3) {
                this.jy("FocusBackgroundColor", b, a);
            }
        }
        get s7() {
            return this.l4;
        }
        set s7(a) {
            let b = this.l4;
            this.l4 = a;
            if (b != this.l4) {
                this.jy("FocusTextColor", b, a);
            }
        }
        get ax() {
            return this.ao;
        }
        set ax(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.jy("BorderWidth", b, a);
            }
        }
        get ke() {
            return this.j6;
        }
        set ke(a) {
            let b = this.j6;
            this.j6 = a;
            {
                this.jy("CornerRadius", b, a);
            }
        }
        get tl() {
            return this.mj;
        }
        set tl(a) {
            let b = this.mj;
            this.mj = a;
            if (b != this.mj) {
                this.jy("OutlinedBackgroundColor", b, a);
            }
        }
        get tn() {
            return this.ml;
        }
        set tn(a) {
            let b = this.ml;
            this.ml = a;
            if (b != this.ml) {
                this.jy("OutlinedDisabledBackgroundColor", b, a);
            }
        }
        get to() {
            return this.mm;
        }
        set to(a) {
            let b = this.mm;
            this.mm = a;
            if (b != this.mm) {
                this.jy("OutlinedDisabledBorderColor", b, a);
            }
        }
        get tp() {
            return this.mn;
        }
        set tp(a) {
            let b = this.mn;
            this.mn = a;
            if (b != this.mn) {
                this.jy("OutlinedDisabledTextColor", b, a);
            }
        }
        get el() {
            return this.b3;
        }
        set el(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.jy("OutlinedDisabledElevation", b, a);
            }
        }
        get ts() {
            return this.mq;
        }
        set ts(a) {
            let b = this.mq;
            this.mq = a;
            if (b != this.mq) {
                this.jy("OutlinedHoverBackgroundColor", b, a);
            }
        }
        get tm() {
            return this.mk;
        }
        set tm(a) {
            let b = this.mk;
            this.mk = a;
            if (b != this.mk) {
                this.jy("OutlinedBorderColor", b, a);
            }
        }
        get eo() {
            return this.b6;
        }
        set eo(a) {
            let b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.jy("OutlinedRestingElevation", b, a);
            }
        }
        get en() {
            return this.b5;
        }
        set en(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.jy("OutlinedHoverElevation", b, a);
            }
        }
        get em() {
            return this.b4;
        }
        set em(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.jy("OutlinedFocusElevation", b, a);
            }
        }
        get bi() {
            return this.au;
        }
        set bi(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.jy("OutlinedBorderWidth", b, a);
            }
        }
        get kx() {
            return this.ka;
        }
        set kx(a) {
            let b = this.ka;
            this.ka = a;
            {
                this.jy("OutlinedCornerRadius", b, a);
            }
        }
        get tu() {
            return this.ms;
        }
        set tu(a) {
            let b = this.ms;
            this.ms = a;
            if (b != this.ms) {
                this.jy("OutlinedRippleColor", b, a);
            }
        }
        get tv() {
            return this.mt;
        }
        set tv(a) {
            let b = this.mt;
            this.mt = a;
            if (b != this.mt) {
                this.jy("OutlinedTextColor", b, a);
            }
        }
        get tt() {
            return this.mr;
        }
        set tt(a) {
            let b = this.mr;
            this.mr = a;
            if (b != this.mr) {
                this.jy("OutlinedHoverTextColor", b, a);
            }
        }
        get tq() {
            return this.mo;
        }
        set tq(a) {
            let b = this.mo;
            this.mo = a;
            if (b != this.mo) {
                this.jy("OutlinedFocusBackgroundColor", b, a);
            }
        }
        get tr() {
            return this.mp;
        }
        set tr(a) {
            let b = this.mp;
            this.mp = a;
            if (b != this.mp) {
                this.jy("OutlinedFocusTextColor", b, a);
            }
        }
        get sk() {
            return this.li;
        }
        set sk(a) {
            let b = this.li;
            this.li = a;
            if (b != this.li) {
                this.jy("FabBackgroundColor", b, a);
            }
        }
        get sm() {
            return this.lk;
        }
        set sm(a) {
            let b = this.lk;
            this.lk = a;
            if (b != this.lk) {
                this.jy("FabDisabledBackgroundColor", b, a);
            }
        }
        get sn() {
            return this.ll;
        }
        set sn(a) {
            let b = this.ll;
            this.ll = a;
            if (b != this.ll) {
                this.jy("FabDisabledBorderColor", b, a);
            }
        }
        get so() {
            return this.lm;
        }
        set so(a) {
            let b = this.lm;
            this.lm = a;
            if (b != this.lm) {
                this.jy("FabDisabledTextColor", b, a);
            }
        }
        get d7() {
            return this.bp;
        }
        set d7(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.jy("FabDisabledElevation", b, a);
            }
        }
        get sr() {
            return this.l6;
        }
        set sr(a) {
            let b = this.l6;
            this.l6 = a;
            if (b != this.l6) {
                this.jy("FabHoverBackgroundColor", b, a);
            }
        }
        get sl() {
            return this.lj;
        }
        set sl(a) {
            let b = this.lj;
            this.lj = a;
            if (b != this.lj) {
                this.jy("FabBorderColor", b, a);
            }
        }
        get ea() {
            return this.bs;
        }
        set ea(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.jy("FabRestingElevation", b, a);
            }
        }
        get d9() {
            return this.br;
        }
        set d9(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.jy("FabHoverElevation", b, a);
            }
        }
        get d8() {
            return this.bq;
        }
        set d8(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.jy("FabFocusElevation", b, a);
            }
        }
        get bd() {
            return this.ap;
        }
        set bd(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.jy("FabBorderWidth", b, a);
            }
        }
        get ku() {
            return this.j7;
        }
        set ku(a) {
            let b = this.j7;
            this.j7 = a;
            {
                this.jy("FabCornerRadius", b, a);
            }
        }
        get st() {
            return this.lq;
        }
        set st(a) {
            let b = this.lq;
            this.lq = a;
            if (b != this.lq) {
                this.jy("FabRippleColor", b, a);
            }
        }
        get su() {
            return this.lr;
        }
        set su(a) {
            let b = this.lr;
            this.lr = a;
            if (b != this.lr) {
                this.jy("FabTextColor", b, a);
            }
        }
        get ss() {
            return this.lp;
        }
        set ss(a) {
            let b = this.lp;
            this.lp = a;
            if (b != this.lp) {
                this.jy("FabHoverTextColor", b, a);
            }
        }
        get sp() {
            return this.ln;
        }
        set sp(a) {
            let b = this.ln;
            this.ln = a;
            if (b != this.ln) {
                this.jy("FabFocusBackgroundColor", b, a);
            }
        }
        get sq() {
            return this.lo;
        }
        set sq(a) {
            let b = this.lo;
            this.lo = a;
            if (b != this.lo) {
                this.jy("FabFocusTextColor", b, a);
            }
        }
        get ta() {
            return this.l8;
        }
        set ta(a) {
            let b = this.l8;
            this.l8 = a;
            if (b != this.l8) {
                this.jy("IconBackgroundColor", b, a);
            }
        }
        get tc() {
            return this.ma;
        }
        set tc(a) {
            let b = this.ma;
            this.ma = a;
            if (b != this.ma) {
                this.jy("IconDisabledBackgroundColor", b, a);
            }
        }
        get td() {
            return this.mb;
        }
        set td(a) {
            let b = this.mb;
            this.mb = a;
            if (b != this.mb) {
                this.jy("IconDisabledBorderColor", b, a);
            }
        }
        get te() {
            return this.mc;
        }
        set te(a) {
            let b = this.mc;
            this.mc = a;
            if (b != this.mc) {
                this.jy("IconDisabledTextColor", b, a);
            }
        }
        get eh() {
            return this.bz;
        }
        set eh(a) {
            let b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.jy("IconDisabledElevation", b, a);
            }
        }
        get th() {
            return this.mf;
        }
        set th(a) {
            let b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.jy("IconHoverBackgroundColor", b, a);
            }
        }
        get tb() {
            return this.l9;
        }
        set tb(a) {
            let b = this.l9;
            this.l9 = a;
            if (b != this.l9) {
                this.jy("IconBorderColor", b, a);
            }
        }
        get ek() {
            return this.b2;
        }
        set ek(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.jy("IconRestingElevation", b, a);
            }
        }
        get ej() {
            return this.b1;
        }
        set ej(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.jy("IconHoverElevation", b, a);
            }
        }
        get ei() {
            return this.b0;
        }
        set ei(a) {
            let b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.jy("IconFocusElevation", b, a);
            }
        }
        get bf() {
            return this.ar;
        }
        set bf(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.jy("IconBorderWidth", b, a);
            }
        }
        get kw() {
            return this.j9;
        }
        set kw(a) {
            let b = this.j9;
            this.j9 = a;
            {
                this.jy("IconCornerRadius", b, a);
            }
        }
        get tj() {
            return this.mh;
        }
        set tj(a) {
            let b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.jy("IconRippleColor", b, a);
            }
        }
        get tk() {
            return this.mi;
        }
        set tk(a) {
            let b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.jy("IconTextColor", b, a);
            }
        }
        get ti() {
            return this.mg;
        }
        set ti(a) {
            let b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.jy("IconHoverTextColor", b, a);
            }
        }
        get tf() {
            return this.md;
        }
        set tf(a) {
            let b = this.md;
            this.md = a;
            if (b != this.md) {
                this.jy("IconFocusBackgroundColor", b, a);
            }
        }
        get tg() {
            return this.me;
        }
        set tg(a) {
            let b = this.me;
            this.me = a;
            if (b != this.me) {
                this.jy("IconFocusTextColor", b, a);
            }
        }
        get h8() {
            return this.e7;
        }
        set h8(a) {
            let b = this.e7;
            this.e7 = a;
            if (b != this.e7) {
                this.jy("InputId", b, a);
            }
        }
        get h6() {
            return this.e6;
        }
        set h6(a) {
            let b = this.e6;
            this.e6 = a;
            if (b != this.e6) {
                this.jy("Id", b, a);
            }
        }
        get gc() {
            return this.e3;
        }
        set gc(a) {
            let b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.jy("Display", b, a);
            }
        }
        get hf() {
            return this.e4;
        }
        set hf(a) {
            let b = this.e4;
            this.e4 = a;
            if (b != this.e4) {
                this.jy("FlexDirection", b, a);
            }
        }
        get hh() {
            return this.e5;
        }
        set hh(a) {
            let b = this.e5;
            this.e5 = a;
            if (b != this.e5) {
                this.jy("FlexGrow", b, a);
            }
        }
        get fw() {
            return this.e1;
        }
        set fw(a) {
            let b = this.e1;
            this.e1 = a;
            if (b != this.e1) {
                this.jy("AlignItems", b, a);
            }
        }
        get e0() {
            return this.ex;
        }
        set e0(a) {
            let b = this.ex;
            this.ex = a;
            if (b != this.ex) {
                this.jy("Value", b, a);
            }
        }
        get ih() {
            return this.e8;
        }
        set ih(a) {
            let b = this.e8;
            this.e8 = a;
            if (b != this.e8) {
                this.jy("Name", b, a);
            }
        }
        get ah() {
            return this.z;
        }
        get eu() {
            return this.cc;
        }
        set eu(a) {
            let b = this.cc;
            this.cc = a;
            this.z = true;
            if (b != this.cc) {
                this.jy("TabIndex", b, a);
            }
        }
        get fy() {
            return this.e2;
        }
        set fy(a) {
            let b = this.e2;
            this.e2 = a;
            if (b != this.e2) {
                this.jy("AriaLabel", b, a);
            }
        }
        get focused() {
            return this.ab;
        }
        set focused(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.jy("IsFocused", b, a);
            }
        }
        get ak() {
            return this.ac;
        }
        set ak(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.jy("IsFocusStyleEnabled", b, a);
            }
        }
        get af() {
            return this.x;
        }
        set af(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.jy("DisableRipple", b, a);
            }
        }
        get ae() {
            return this.w;
        }
        set ae(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.jy("ActualDisableRipple", b, a);
            }
        }
        get al() {
            return this.ad;
        }
        set al(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.jy("IsHover", b, a);
            }
        }
        get disabled() {
            return this.aa;
        }
        set disabled(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.jy("IsDisabled", b, a);
            }
        }
        get ag() {
            return this.y;
        }
        set ag(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.jy("DisableTransitions", b, a);
            }
        }
        jz() {
            this.jq();
            this.view.aq(this.ni, BrushUtil.g(0, 0, 0, 0));
            this.j2();
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        jq() {
            this.view.aa();
        }
        onDetachedFromUI() {
            this.view.ae();
        }
        onAttachedToUI() {
            this.view.ac();
        }
        appendButtonContent(a) {
            this.view.z(a);
        }
        am() {
            return this.view.g();
        }
        ey() {
            return this.b();
        }
        gg() {
            let a = this.b();
            return a.ab();
        }
        b() {
            let a = this.view.q;
            let b = this.view.r;
            let c = new ButtonVisualModelExport();
            let d = UIElementPropertyAccessorFactory.c.a(12, 0);
            let e = d.b(a);
            let f = this.view.a();
            c.s = f[0];
            c.q = f[1];
            c.p = NativeUI.c(a);
            c.t = NativeUI.i(a);
            c.h = this.i;
            c.i = this.l;
            c.c = AppearanceHelper.a(NativeUI.ag(a));
            c.g = AppearanceHelper.a(this.nk);
            c.d = AppearanceHelper.a(this.nh);
            c.a = AppearanceHelper.a(this.m7);
            c.u = this.cg;
            c.e = AppearanceHelper.a(this.ni);
            c.ah = this.kc;
            c.b = AppearanceHelper.a(NativeUI.af(a));
            c.j = this.p;
            c.f = AppearanceHelper.a(NativeUI.ah(b));
            c.o = this.aw;
            c.x = this.gc;
            c.y = this.hf;
            c.z = this.hh;
            c.w = this.fw;
            c.v = this.view.r.getNativeElement().innerText;
            c.aa = this.ih;
            c.m = this.focused;
            c.k = this.ae;
            c.n = this.al;
            c.l = this.disabled;
            if (this.v != null) {
                let g = this.v;
                if (this.view != null && g.n == null) {
                    let h = this.view.k;
                    let i = FontUtil.getFontInfoFromString(h, g.fontString);
                    g.n = i.n;
                    g.d = i.d;
                    g.o = i.o;
                    g.q = i.q;
                    g.r = i.r;
                    g.s = i.s;
                }
                if (g.n != null) {
                    c.ac = g.n;
                }
                if (!isNaN_(g.d)) {
                    c.r = g.d;
                }
                if (g.s != null) {
                    c.ag = g.s;
                }
                if (g.q != null) {
                    c.ae = g.q;
                }
                if (g.o != null) {
                    c.ad = g.q;
                }
            }
            return c;
        }
        provideContainer(a) {
            this.view.ad(a);
        }
    }
    XButton.$t = /*@__PURE__*/ markType(XButton, 'XButton', Base.$, [INotifyPropertyChanged_$type]);
    XButton.rs = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.rg = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    XButton.p7 = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    XButton.s = 1;
    XButton.rj = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.rk = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.rl = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.du = 0;
    XButton.dx = 2;
    XButton.dw = 4;
    XButton.dv = 8;
    XButton.ri = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.rq = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.kr = /*@__PURE__*/ new CornerRadius(0, 4);
    XButton.ba = NaN;
    XButton.rh = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.rr = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.rp = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.ro = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    XButton.rm = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    XButton.rn = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.ql = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.qm = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.qn = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.dh = 0;
    XButton.dk = 0;
    XButton.dj = 0;
    XButton.di = 0;
    XButton.qk = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.qs = null;
    XButton.ko = /*@__PURE__*/ new CornerRadius(0, 4);
    XButton.a7 = NaN;
    XButton.qj = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.qt = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.qr = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.qq = /*@__PURE__*/ BrushUtil.g(13, 228, 28, 119);
    XButton.qo = /*@__PURE__*/ BrushUtil.g(30, 228, 28, 119);
    XButton.qp = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.q7 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.q8 = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    XButton.q9 = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.dq = 0;
    XButton.dt = 0;
    XButton.ds = 0;
    XButton.dr = 0;
    XButton.q6 = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    XButton.re = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.kq = /*@__PURE__*/ new CornerRadius(0, 4);
    XButton.a9 = 1;
    XButton.q5 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.rf = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.rd = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.rc = /*@__PURE__*/ BrushUtil.g(13, 228, 28, 119);
    XButton.ra = /*@__PURE__*/ BrushUtil.g(30, 228, 28, 119);
    XButton.rb = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.qw = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.qx = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.qy = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.dl = 0;
    XButton.dp = 0;
    XButton.dn = 0;
    XButton.dm = 0;
    XButton.qv = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.q3 = null;
    XButton.kp = /*@__PURE__*/ new CornerRadius(0, 28);
    XButton.a8 = NaN;
    XButton.qu = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.q4 = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.q2 = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.q1 = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    XButton.qz = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.q0 = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.qa = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.qb = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.qc = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.dd = 0;
    XButton.dg = 6;
    XButton.df = 12;
    XButton.de = 12;
    XButton.p9 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.qh = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.kn = /*@__PURE__*/ new CornerRadius(0, 28);
    XButton.a6 = NaN;
    XButton.p8 = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    XButton.qi = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.qg = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.qf = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    XButton.qd = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    XButton.qe = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    XButton.o9 = /*@__PURE__*/ BrushUtil.g(100, 33, 150, 243);
    XButton.ox = /*@__PURE__*/ BrushUtil.g(70, 33, 150, 243);
    XButton.no = /*@__PURE__*/ BrushUtil.g(40, 33, 150, 243);
    XButton.q = 2;
    XButton.o0 = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.o1 = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.o2 = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.cx = 0;
    XButton.c0 = 0;
    XButton.cz = 0;
    XButton.cy = 2;
    XButton.oz = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.o7 = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.kj = /*@__PURE__*/ new CornerRadius(0, 3);
    XButton.a2 = NaN;
    XButton.oy = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.o8 = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.o6 = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.o5 = /*@__PURE__*/ BrushUtil.g(255, 27, 135, 220);
    XButton.o3 = /*@__PURE__*/ BrushUtil.g(255, 21, 112, 184);
    XButton.o4 = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.n2 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.n3 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.n4 = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.cl = 0;
    XButton.co = 0;
    XButton.cn = 0;
    XButton.cm = 2;
    XButton.n1 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.n9 = /*@__PURE__*/ BrushUtil.g(100, 33, 150, 243);
    XButton.kg = /*@__PURE__*/ new CornerRadius(0, 3);
    XButton.az = NaN;
    XButton.n0 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.oa = /*@__PURE__*/ BrushUtil.g(255, 119, 119, 119);
    XButton.n8 = /*@__PURE__*/ BrushUtil.g(255, 119, 119, 119);
    XButton.n7 = /*@__PURE__*/ BrushUtil.g(26, 33, 150, 243);
    XButton.n5 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.n6 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.oo = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.op = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    XButton.oq = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.ct = 0;
    XButton.cw = 0;
    XButton.cv = 0;
    XButton.cu = 2;
    XButton.on = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.ov = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.ki = /*@__PURE__*/ new CornerRadius(0, 3);
    XButton.a1 = 1;
    XButton.om = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.ow = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.ou = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.ot = /*@__PURE__*/ BrushUtil.g(26, 33, 150, 243);
    XButton.or = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.os = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.od = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.oe = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.of = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.cp = 0;
    XButton.cs = 0;
    XButton.cr = 0;
    XButton.cq = 2;
    XButton.oc = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.ok = null;
    XButton.kh = /*@__PURE__*/ new CornerRadius(0, 28);
    XButton.a0 = NaN;
    XButton.ob = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    XButton.ol = /*@__PURE__*/ BrushUtil.g(255, 119, 119, 119);
    XButton.oj = /*@__PURE__*/ BrushUtil.g(255, 119, 119, 119);
    XButton.oi = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    XButton.og = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.oh = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.nr = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.ns = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    XButton.nt = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    XButton.ch = 0;
    XButton.ck = 0;
    XButton.cj = 0;
    XButton.ci = 2;
    XButton.nq = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    XButton.ny = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.kf = /*@__PURE__*/ new CornerRadius(0, 28);
    XButton.ay = NaN;
    XButton.np = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    XButton.nz = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.nx = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.nw = /*@__PURE__*/ BrushUtil.g(255, 27, 135, 220);
    XButton.nu = /*@__PURE__*/ BrushUtil.g(255, 21, 112, 184);
    XButton.nv = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    XButton.h = 2;
    XButton.ew = 0;
    XButton.ev = 0;
    return XButton;
})();
