/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { IIcon_$type } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let IconView = /*@__PURE__*/ (() => {
    class IconView extends Base {
        constructor() {
            super();
            this.b = null;
            this.h = null;
            this.c = null;
            this.g = new List$1(Delegate_$type, 0);
            this.m = null;
            this.d = true;
            this.i = null;
            this.j = null;
        }
        u() {
        }
        e() {
            return true;
        }
        get k() {
            return this.i;
        }
        get l() {
            return null;
        }
        get f() {
            return true;
        }
        s(a) {
            if (a == null) {
                for (let b of fromEnum(this.g)) {
                    b();
                }
                this.g.clear();
                if (this.i != null) {
                    this.i.unlistenAll();
                }
            }
            this.h = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            this.h.rootWrapper.setStyleProperty("display", "flex");
            this.h.rootWrapper.setStyleProperty("flex-direction", "row");
            this.h.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.h.rootWrapper.setStyleProperty("align-items", "center");
            this.w();
            let c = this.h.createElementNS("svg", "http://www.w3.org/2000/svg");
            c.setStyleProperty("position", "absolute");
            c.setStyleProperty("top", "0");
            c.setStyleProperty("left", "0");
            c.setStyleProperty("right", "0");
            c.setStyleProperty("bottom", "0");
            c.setAttribute("viewBox", "0 0 24 24");
            this.i = c;
            let d = this.h.createElementNS("path", "http://www.w3.org/2000/svg");
            d.setAttribute("d", "");
            this.i.append(d);
            if (this.m != null) {
                d.setAttribute("d", this.m);
            }
            this.j = d;
            this.h.append(this.i);
            this.g.add(c.listen("click", runOn(this, this.r)));
            this.b.bd();
        }
        x(a) {
            if (this.m != a) {
                this.m = a;
                if (this.j != null) {
                    this.j.setAttribute("d", this.m);
                }
            }
        }
        w() {
            this.h.rootWrapper.setStyleProperty("width", "1.5rem");
            this.h.rootWrapper.setStyleProperty("height", "1.5rem");
        }
        n(a) {
        }
        v() {
            if (this.e()) {
            }
        }
        o(a) {
            this.b.ba();
        }
        p(a) {
            this.b.bb();
        }
        q() {
            this.d = true;
            this.g.add(this.h.rootWrapper.listen("mouseenter", runOn(this, this.o)));
            this.g.add(this.h.rootWrapper.listen("mouseleave", runOn(this, this.p)));
        }
        t() {
            this.d = false;
            for (let a of fromEnum(this.g)) {
                a();
            }
            this.g.clear();
        }
        y(a) {
            if (a != null) {
                this.h.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        a() {
            let rect_ = this.h.rootWrapper.getNativeElement().getBoundingClientRect();
            let a = (rect_.top);
            let b = (rect_.left);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
        r(a) {
            this.b.a8();
        }
    }
    IconView.$t = /*@__PURE__*/ markType(IconView, 'IconView');
    return IconView;
})();
/**
 * @hidden
 */
export let XIcon = /*@__PURE__*/ (() => {
    class XIcon extends Base {
        constructor() {
            super();
            this._view = null;
            this.bj = XIcon.bz;
            this.bn = XIcon.b3;
            this.bk = XIcon.b0;
            this.bl = XIcon.b1;
            this.bm = XIcon.b2;
            this.n = XIcon.u;
            this.o = XIcon.v;
            this.bo = XIcon.bz;
            this.bt = XIcon.b3;
            this.af = null;
            this.bp = XIcon.b0;
            this.bq = XIcon.b1;
            this.bs = XIcon.b2;
            this.p = XIcon.u;
            this.r = XIcon.v;
            this.d = null;
            this.br = null;
            this.ae = "ig-icon-" + XIcon.ab++;
            this.z = 0;
            this.f = false;
            this.ad = null;
            this.h = false;
            this.g = false;
            this.q = 1;
            this.clicked = null;
            this.propertyChanged = null;
            let a = new IconView();
            a.b = this;
            this.view = a;
            this.view.u();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        bc(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.be(a, b, c);
        }
        be(a, b, c) {
            switch (a) {
                case "Fill":
                case "Stroke":
                case "StrokeThickness":
                case "HoverFill":
                case "HoverStroke":
                case "HoverStrokeThickness":
                    this.bi();
                    break;
                case "ActualFill":
                case "ActualStroke":
                case "ActualHoverFill":
                case "ActualHoverStroke":
                case "ActualStrokeThickness":
                case "ActualHoverStrokeThickness":
                case "SVGPath":
                    this.bg();
                    break;
                case "Opacity":
                    this.bh();
                    break;
            }
        }
        bi() {
            this.bu = this.fill != null ? this.fill : XIcon.bz;
            this.bv = this.b4 != null ? this.b4 : XIcon.b0;
            this.bx = this.b7 != null ? this.b7 : XIcon.b2;
            this.bw = this.b5 != null ? this.b5 : XIcon.b1;
            this.t = !isNaN_(this.y) ? this.y : XIcon.v;
            this.s = !isNaN_(this.w) ? this.w : XIcon.u;
            this.by = this.b8 != null ? this.b8 : XIcon.b3;
        }
        get j() {
            return this.svgPath != null && !this.view.f;
        }
        bh() {
            NativeUI.u(this.view.k, this.x);
        }
        bg() {
            let a = this.view.k;
            if (this.j) {
                let b = this.view.l;
                if (this.l) {
                    NativeUI.p(b, this.bv);
                    NativeUI.w(b, this.bw);
                    NativeUI.z(b, this.s);
                }
                else {
                    NativeUI.p(b, this.bu);
                    NativeUI.w(b, this.bx);
                    NativeUI.z(b, this.t);
                }
            }
            else {
                if (this.svgPath != null) {
                    this.view.x(this.svgPath);
                }
                let c = this.view.k;
                if (this.l) {
                    if (this.bv != null) {
                        NativeUI.p(c, this.bv);
                    }
                    if (this.bw != null) {
                        NativeUI.w(c, this.bw);
                    }
                    if (!isNaN_(this.s)) {
                        NativeUI.z(c, this.s);
                    }
                }
                else {
                    if (this.bu != null) {
                        NativeUI.p(c, this.bu);
                    }
                    if (this.bx != null) {
                        NativeUI.w(c, this.bx);
                    }
                    if (!isNaN_(this.t)) {
                        NativeUI.z(c, this.t);
                    }
                }
            }
            if (this.e != null) {
                this.view.y(this.e);
            }
            if (this.by != null) {
                NativeUI.o(this.view.k, this.by);
            }
        }
        get bu() {
            return this.bj;
        }
        set bu(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.bc("ActualFill", b, a);
            }
        }
        get by() {
            return this.bn;
        }
        set by(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.bc("ActualTextColor", b, a);
            }
        }
        get bv() {
            return this.bk;
        }
        set bv(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.bc("ActualHoverFill", b, a);
            }
        }
        get bw() {
            return this.bl;
        }
        set bw(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.bc("ActualHoverStroke", b, a);
            }
        }
        get bx() {
            return this.bm;
        }
        set bx(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.bc("ActualStroke", b, a);
            }
        }
        get s() {
            return this.n;
        }
        set s(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.bc("ActualHoverStrokeThickness", b, a);
            }
        }
        get t() {
            return this.o;
        }
        set t(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.bc("ActualStrokeThickness", b, a);
            }
        }
        get fill() {
            return this.bo;
        }
        set fill(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.bc("Fill", b, a);
            }
        }
        get b8() {
            return this.bt;
        }
        set b8(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.bc("TextColor", b, a);
            }
        }
        get svgPath() {
            return this.af;
        }
        set svgPath(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.bc("SVGPath", b, a);
            }
        }
        get b4() {
            return this.bp;
        }
        set b4(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.bc("HoverFill", b, a);
            }
        }
        get b5() {
            return this.bq;
        }
        set b5(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.bc("HoverStroke", b, a);
            }
        }
        get b7() {
            return this.bs;
        }
        set b7(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.bc("Stroke", b, a);
            }
        }
        get w() {
            return this.p;
        }
        set w(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.bc("HoverStrokeThickness", b, a);
            }
        }
        get y() {
            return this.r;
        }
        set y(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.bc("StrokeThickness", b, a);
            }
        }
        ba() {
            this.l = true;
        }
        bb() {
            this.l = false;
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.bc("TextStyle", b, a);
            }
        }
        get b6() {
            return this.br;
        }
        set b6(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.bc("HoverTextColor", b, a);
            }
        }
        get av() {
            return this.ae;
        }
        set av(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.bc("Id", b, a);
            }
        }
        get i() {
            return this.f;
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.z;
            this.z = a;
            this.f = true;
            if (b != this.z) {
                this.bc("TabIndex", b, a);
            }
        }
        get an() {
            return this.ad;
        }
        set an(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.bc("AriaLabel", b, a);
            }
        }
        get l() {
            return this.h;
        }
        set l(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.bc("IsHover", b, a);
            }
        }
        get disabled() {
            return this.g;
        }
        set disabled(a) {
            let b = this.g;
            this.g = a;
            if (b != this.g) {
                this.bc("IsDisabled", b, a);
            }
        }
        get x() {
            return this.q;
        }
        set x(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.bc("Opacity", b, this.q);
            }
        }
        bd() {
        }
        onDetachedFromUI() {
            this.view.t();
        }
        onAttachedToUI() {
            this.view.q();
        }
        a8() {
            if (this.disabled) {
                return;
            }
            if (this.clicked != null) {
                this.clicked(this, new IconClickedEventArgs());
            }
        }
        m() {
            return this.view.e();
        }
        ac() {
            return this.a();
        }
        ap() {
            let a = this.a();
            return a.j();
        }
        a() {
            let a = new IconVisualModelExport();
            let b = this.view.k;
            a.a = AppearanceHelper.a(NativeUI.ah(b));
            a.c = AppearanceHelper.a(NativeUI.ah(b));
            a.b = AppearanceHelper.a(NativeUI.ai(b));
            a.d = this.t;
            let c = this.view.a();
            a.h = c[0];
            a.f = c[1];
            a.e = NativeUI.c(b);
            a.i = NativeUI.i(b);
            a.svgPath = this.svgPath;
            if (this.e != null) {
                let d = this.e;
                if (this.view != null && d.n == null) {
                    let e = this.view.h;
                    let f = FontUtil.getFontInfoFromString(e, d.fontString);
                    d.n = f.n;
                    d.d = f.d;
                    d.o = f.o;
                    d.q = f.q;
                    d.r = f.r;
                    d.s = f.s;
                }
                if (d.n != null) {
                    a.l = d.n;
                }
                if (!isNaN_(d.d)) {
                    a.g = d.d;
                }
                if (d.s != null) {
                    a.p = d.s;
                }
                if (d.q != null) {
                    a.n = d.q;
                }
                if (d.o != null) {
                    a.m = d.q;
                }
            }
            return a;
        }
        provideContainer(a) {
            this.view.s(a);
        }
    }
    XIcon.$t = /*@__PURE__*/ markType(XIcon, 'XIcon', Base.$, [INotifyPropertyChanged_$type, IIcon_$type]);
    XIcon.bz = null;
    XIcon.b3 = null;
    XIcon.b2 = null;
    XIcon.b0 = null;
    XIcon.b1 = null;
    XIcon.v = 0;
    XIcon.u = 0;
    XIcon.ab = 0;
    return XIcon;
})();
